        org 32768
mode:   equ 0
main_loop:
        halt
        call one_scroll
        ld bc,$7ffe
        in a,(c)
        and 1
        jr nz, main_loop
        ret

one_scroll:
        ld a,(bpos)
        or a
        jr z,move_text
        dec a
        ld (bpos),a
        jr do_scroll
move_text:
text_adr: equ $+1
        ld hl,text
        ld a,(hl)
        inc hl
        ld (text_adr),hl
        cp 13
        jr nz,get_char
        ld hl,text
        ld a,(hl)
        inc hl
        ld (text_adr),hl
get_char:
        sub 32
if mode = 1
        ld h,0
        ld l,a
        push hl
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,hl
        pop de
        add hl,de
        ld de,font
        add hl,de
        ld de,buf

        ld a,(hl)
        dec a
        ld (bpos),a
        inc hl
else
        ld h,0
        ld l,a
        push hl
        ld de,size_tab
        add hl,de
        ld a,(hl)
        dec a
        ld (bpos),a

        pop hl
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,hl
        add hl,hl
        ld de,font
        add hl,de
        ld de,buf
endif

        rept 32
          ldi
        endm

do_scroll:
        ld hl,20672+31
        ld de,buf+1
        ld b,2
loop0:
        push bc
        push hl
        ld b,8
loop1:
        push hl
        ld c,32
        ld a,(de)
        rla
        ld (de),a
        dec de
        ld a,(de)
        rla
        ld (de),a
        inc de
loop2:
        ld a,(hl)
        rla
        ld (hl),a
        dec hl
        dec c
        jr nz,loop2
        inc de
        inc de
        pop hl
        inc h
        djnz loop1
        pop hl
        ld bc,32
        add hl,bc
        pop bc
        djnz loop0
        ret

buf:	ds 32
bpos:	db 0
text:	defm "Scrollery, czesc 2 (c) 2012 mat for speccy.pl...   "
        db 13
if mode = 1
font:   incbin "chars2.bin"
else
size_tab:
        db 10, 4, 7,14,15,15,15, 4, 5, 5,12,12, 4,12, 4,15
        db 15, 6,15,15,15,15,15,15,15,15, 4, 4, 9,12, 9,13
        db 15,15,15,15,15,15,15,15,15, 4,15,15,15,15,15,15
        db 15,15,15,15,14,15,15,15,15,14,15, 5,15, 5,11,15
        db  1,12,12,12,12,12, 7,12,12, 4, 8,12, 6,14,12,12
        db 12,12,12,12, 7,12,12,14,12,12,12, 6, 4, 6,15,15
font:   incbin "chars2a.bin"
endif
        end 32768
