    org 32768

main_loop:
    halt
;ld a,1
;out ($fe),a
    call one_scroll
;ld a,7
;out($fe),a
    ld bc,$7ffe
    in a,(c)
    and 1
    jr nz, main_loop
    ret

one_scroll:
    ld a,(bpos)
    or a
    jr z,move_text
    dec a
    ld (bpos),a
    jr do_scroll
move_text:
    ld a,7
    ld (bpos),a
text_adr: equ $+1
    ld hl,text
    ld a,(hl)
    inc hl
    ld (text_adr),hl
    cp 13
    jr nz,get_char
    ld hl,text
    ld a,(hl)
    inc hl
    ld (text_adr),hl
get_char:
    ld h,0
    ld l,a
    add hl,hl
    add hl,hl
    add hl,hl
    ld de,15360
    add hl,de
    ld de,buf

    rept 8
      ldi
    endm

do_scroll:
    ld hl,20608+31
    ld de,buf
    ld b,8
loop1:
    ld a,(de)
    rla
    ld (de),a
    jr c,is_set
    ld a,0
    jr is_reset
is_set:
    ld a,15
is_reset:

    push bc
    ld b,4
loop2:
    push af
    push hl
    ld c,32
loop3:
    rld
    dec l
    dec c
    jr nz,loop3
    pop hl
    inc     h
    ld      a,h
    and     7
    jr      nz,skip
    ld      a,l
    add     a,32
    ld      l,a
    jr      c,skip
    ld      a,h
    sub     8
    ld      h,a
skip:
    pop af
    djnz loop2
    pop bc
    inc de
    djnz loop1
    ret

buf:    ds 8
bpos:   db 0
text:   defm "Scrollery, czesc 2 (c) 2012 mat for speccy.pl...   "
    db 13
    end 32768
